//---------------------------------------------------------------------------
#ifndef CheckBoxRegH
#define CheckBoxRegH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <registry.hpp>
#include <buttons.hpp>
#include <myreg.hpp>
#include "RegSpeedButton.h"

//---------------------------------------------------------------------------
class PACKAGE TCheckBoxReg : public TCheckBox
{
private:
    bool bGotValue;
    TColor FColor;
    ERegType            FRegType;
    ERegRootKey         FRegRoot;

    int FRegDW_read;
    int FRegDW_checked;
    int FRegDW_unchecked;
    int FRegDW_default;
    //bool FRegNotSafeToDel; //Is it safe to delete if it is default?


    System::AnsiString  FRegSTR_read;
    System::AnsiString  FRegSTR_checked;
    System::AnsiString  FRegSTR_unchecked;
    System::AnsiString  FRegSTR_default;
    System::AnsiString  FRegKeyName;
    System::AnsiString  FRegValueName;


    static TRegSpeedButton* FSButton1;
    static TRegSpeedButton* FSButton2;
    static TRichEdit* FEdit;
    //static bool bNeedEnableButton;
    //static bool bNeedShowText;
    //static int FCurrentCount;
    static TCheckBoxReg* FCurrentCBR;

protected:
    void __fastcall Click(void);
    void __fastcall Loaded(void);
    void __fastcall SetRootKey(TRegistry* reg);
    void __fastcall GetRegValue(void);
    bool __fastcall ValueChanged(void);
    void __fastcall MouseMove(TShiftState Shift, int X, int Y);
public:
    static void __fastcall SetFriend(TRegSpeedButton* fs1,TRegSpeedButton* fs2,TRichEdit* fe);
    __fastcall TCheckBoxReg(TComponent* Owner);
    void __fastcall SetRegValue(void);
    //TCheckBoxReg* GetCurrentCBR(void);
    //static void SetCurrentCBR(TCheckBoxReg* cbr);
__published:
    __property ERegType RegType={read=FRegType,write=FRegType};
    __property ERegRootKey RegRoot={read=FRegRoot,write=FRegRoot};
    __property System::AnsiString RegKeyName={read=FRegKeyName,write=FRegKeyName};
    __property System::AnsiString RegValueName={read=FRegValueName,write=FRegValueName};

    __property int RegDW_checked={read=FRegDW_checked,write=FRegDW_checked};
    __property int RegDW_unchecked={read=FRegDW_unchecked,write=FRegDW_unchecked};
    __property int RegDW_default={read=FRegDW_default,write=FRegDW_default};
    //__property bool RegNotSafeToDel={read=FRegNotSafeToDel,write=FRegNotSafeToDel};
    __property System::AnsiString RegSTR_checked={read=FRegSTR_checked,write=FRegSTR_checked};
    __property System::AnsiString RegSTR_unchecked={read=FRegSTR_unchecked,write=FRegSTR_unchecked};
    __property System::AnsiString RegSTR_default={read=FRegSTR_default,write=FRegSTR_default};

};
TCheckBoxReg* TCheckBoxReg::FCurrentCBR=NULL;
TRegSpeedButton* TCheckBoxReg::FSButton1=NULL;
TRegSpeedButton* TCheckBoxReg::FSButton2=NULL;
TRichEdit* TCheckBoxReg::FEdit=NULL;
//int TCheckBoxReg::FCurrentCount=0;
//bool TCheckBoxReg::bNeedEnableButton=true;
//bool TCheckBoxReg::bNeedShowText=true;
//---------------------------------------------------------------------------
#endif
