//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "EditReg.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TEditReg *)
{
    new TEditReg(NULL);
}
//---------------------------------------------------------------------------
__fastcall TEditReg::TEditReg(TComponent* Owner)
    : TEdit(Owner)
{
    //note that Text is NULL in constructor than init after that [so changed!]
    bGotValue=FALSE;
    bValueChanged=FALSE;
    bInProcess=FALSE;
}
//---------------------------------------------------------------------------
namespace Editreg
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TEditReg)};
        RegisterComponents("Samples", classes, 0);
    }
}
//---------------------------------------------------------------------------
//Override default loaded!
void __fastcall TEditReg::Loaded()
{
    /*
    int i;
    if(bNeedEnableButton&&FSButton1==NULL&&FSButton2==NULL&&bNeedShowText)
    {
       for(i=0;i<this->Owner->ComponentCount;i++)
        {
            if(this->Owner->Components[i]->ClassNameIs("TRegSpeedButton"))
            {
               if(this->Owner->Components[i]->Name.UpperCase()==("SBUTTONOK"))
                    FSButton1=(TRegSpeedButton*)(this->Owner->Components[i]);
               if(this->Owner->Components[i]->Name.UpperCase()==("SBUTTONAPPLY"))
                    FSButton2=(TRegSpeedButton*)(this->Owner->Components[i]);
            }
            if(this->Owner->Components[i]->ClassNameIs("TRichEdit"))
            {
                if(this->Owner->Components[i]->Name.UpperCase()==("EDITTEXT"))
                    FEdit=(TRichEdit*)(this->Owner->Components[i]);
            }


        }
        if(FSButton1==NULL&&FSButton2==NULL)
            bNeedEnableButton=false;
        else
            bNeedEnableButton=true;
        if(FEdit==NULL)
            bNeedShowText=false;
    }

    */

    //ShowMessage((FSButton1==NULL)?"NULL item init":"NOT null item init");
    TEdit::Loaded();
    Text="";
    GetRegValue();
}

//Function to Set Root Key of current Tregistry obj
void __fastcall TEditReg::SetRootKey(TRegistry* reg)
{
    switch(FRegRoot)
    {
        case HKLM:
             reg->RootKey=HKEY_LOCAL_MACHINE;
             break;
        case HKUS:
             reg->RootKey=HKEY_USERS;
             break;
        case HKCU:
             reg->RootKey=HKEY_CURRENT_USER;
             break;
        case HKCL:
             reg->RootKey=HKEY_CLASSES_ROOT;
             break;
    }
    return;
}

//Read reg values
void __fastcall TEditReg::GetRegValue()
{
    TRegistry* Reg=new TRegistry();
    this->Enabled=true;
    this->SetRootKey(Reg);

    try
    {
    if(!FRegKeyName.IsEmpty())
    {
        if(!Reg->OpenKey(FRegKeyName,false))
        {
            //ShowMessage("Error open RegKey!"+FRegKeyName);
            //this->Enabled=false;
            //bug reported by "Misty & Calvin ,auto create keys
            FRegDW_read=FRegDW_default;
            FRegSTR_read=FRegSTR_default;
            bGotValue=true;
        }
        else
        {
            //ShowMessage("Open OK!");
            if(!FRegValueName.IsEmpty())
            {
                if(Reg->ValueExists(FRegValueName))
                {
                    switch(FRegType)
                    {
                        case B_INARY:
                        Reg->ReadBinaryData(FRegValueName,&FRegDW_read,4);
                        break;
                        case D_WORD:
                        FRegDW_read=Reg->ReadInteger(FRegValueName);
                        break;
                        case S_TRING:
                        FRegSTR_read=(Reg->ReadString(FRegValueName));
                    }
                }
                else
                {
                    FRegDW_read=FRegDW_default;
                    FRegSTR_read=FRegSTR_default;
                }
                switch(FRegType)
                {
                    case B_INARY:
                        break;
                    case D_WORD:
                        //if(FRegDW_read==FRegDW_checked)
                        if(FRegHex)
                            this->Text="0x"+IntToHex(FRegDW_read,8);
                        else
                            this->Text=IntToStr(FRegDW_read);
                        break;
                    case S_TRING:
                        this->Text=FRegSTR_read;
                }
                bGotValue=true;
            }
            Reg->CloseKey();
        }
    }
    }//end try
    catch(ERegistryException &E)
    {
        //ShowMessage(E.Message);
        this->Enabled=false;
        delete Reg;
        return;
    }
    catch(EConvertError &E)
    {
        //ShowMessage(E.Message);
        this->Enabled=false;
        return;
    }
    delete Reg;
}

//Write to registry
void __fastcall TEditReg::SetRegValue()
{
    int value;
    System::AnsiString svalue;
    TRegistry* Reg=new TRegistry();
    if(this->ValueChanged())
    {
        //ShowMessage("writing!"+this->FRegValueName);
        this->SetRootKey(Reg);
        try
        {
            //ShowMessage("Error open RegKey for writing!");
        if(Reg->OpenKey(FRegKeyName,true))
        {
            switch(FRegType)
            {
                //I use regDW_read for both Binary and DWord
                //do not set _default value to either  _checked or _unchecked
                //If you are not sure that the value are safe to delete!
                case B_INARY:
                break;
                case D_WORD:
                value=StrToInt(Text);
                Reg->WriteInteger(FRegValueName,value);
                FRegDW_read=value;
                break;
                case S_TRING:
                svalue=this->Text;
                Reg->WriteString(FRegValueName,svalue);
                FRegSTR_read=svalue;
            }
            Font->Color=clWindowText;
            if(TEditReg::FSButton1!=NULL)
                FSButton1->Increase(-1);
            if(TEditReg::FSButton2!=NULL)
                FSButton2->Increase(-1);
            bCounted=false;

        }
        else
        {
            this->Enabled=false;
        }

        }//end try


        catch(ERegistryException &E)
        {
            ShowMessage(E.Message);
            this->Enabled=false;
            delete Reg;
            return;
        }
        catch(EConvertError &E)
        {
            ShowMessage(E.Message);
            return;
        }

    }
    delete Reg;
}

void __fastcall TEditReg::MouseMove(TShiftState Shift, int X, int Y)
{
    //TFontStyles fns;
    //if(bNeedShowText)
    //ShowMessage((TEditReg::FEdit==NULL)?"NULL":"NOT NULL");
    System::AnsiString sText;
    TEdit::MouseMove(Shift,X,Y);

    if(FEdit!=NULL)
    {
    switch(FRegRoot)
    {
        case HKLM:
             sText="\"HKEY_LOCAL_MACHINE"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKUS:
             sText="\"HKEY_USERS"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKCU:
             sText="\"HKEY_CURRENT_USER"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKCL:
             sText="\"HKEY_CLASS_ROOTS"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
    }

    switch(FRegType)
    {
        case B_INARY:
             sText=sText+","+this->Text+","+"\"REG_BINARY\"";
             break;
        case D_WORD:
             sText=sText+","+this->Text+","+"\"REG_DWORD\"";
             break;
        case S_TRING:
             sText=sText+",\""+this->Text+"\","+"\"REG_SZ\"";
             break;
    }
    FEdit->Text=sText;

    //FEdit->Align=alNone;
    //FEdit->Width=340;
    }

}
//----------------------------------------------
void __fastcall TEditReg::Change()
{

    int value;
    System::AnsiString svalue;
    //    ShowMessage((TEditReg::FEdit==NULL)?"NULL":"NOT NULL");
    TEdit::Change();
    if(bGotValue&&!bInProcess)
    {
        bInProcess=TRUE;
        bValueChanged=FALSE;
        try
        {
        switch(FRegType)
        {
           case B_INARY:
                break;
           case D_WORD:
                if(FRegHex)
                {
                    if(Text.Trim().SubString(0,2)!="0x"||Text.Trim().Length()<=2)
                    {
                        Text="0x0";
                        SelStart=2;
                    }
                }
                else
                {
                    if(Text.Trim().IsEmpty())
                    {
                        Text="0";
                    }
                }
                value=StrToInt(this->Text);
                if(FRegDW_read!=value)
                    bValueChanged=TRUE;
                break;
           case S_TRING:
                svalue=this->Text;
                if(FRegSTR_read!=svalue)
                    bValueChanged=TRUE;
                break;
         }
         if(bValueChanged)
         {
            if(!bCounted) //haven't been counted into speedbutton
            {
                this->Font->Color=clRed;
                if(TEditReg::FSButton1!=NULL)
                    FSButton1->Increase(1);
                if(TEditReg::FSButton2!=NULL)
                    FSButton2->Increase(1);
                bCounted=true;
            }
         }
         else
         {
            if(bCounted)
            {
                this->Font->Color=clWindowText;
                if(TEditReg::FSButton1!=NULL)
                    FSButton1->Increase(-1);
                if(TEditReg::FSButton2!=NULL)
                    FSButton2->Increase(-1);
                bCounted=false;
            }
         }


         //if(bNeedEnableButton)
         {
            if(TEditReg::FSButton1!=NULL)
            {
                //FSButton1->Enabled=true;
                //FSButton1->Enabled=(FCurrentCount>0)?true:false;
                FSButton1->EnableDisable();
            }
            if(TEditReg::FSButton2!=NULL)
            {
                //FSButton2->Enabled=true;
                //FSButton2->Enabled=(FCurrentCount>0)?true:false;
                FSButton2->EnableDisable();
            }
         }
         }

         catch(EConvertError &E)
         {
            ShowMessage(E.Message);
            Undo();

            ClearUndo();
            bInProcess=FALSE;
            return;
         }
         bInProcess=FALSE;

    }
}

bool __fastcall TEditReg::ValueChanged()
{
    return bValueChanged;
}

void __fastcall TEditReg::SetFriend(TRegSpeedButton* fs1,TRegSpeedButton* fs2,TRichEdit* fe)
{
    if(fs1!=NULL)
        FSButton1=fs1;
    if(fs2!=NULL)
        FSButton2=fs2;
    if(fe!=NULL)
        FEdit=fe;
}

