//---------------------------------------------------------------------------
#ifndef EditRegH
#define EditRegH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <registry.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <buttons.hpp>
#include <myreg.hpp>
#include "RegSpeedButton.h"
//---------------------------------------------------------------------------
class PACKAGE TEditReg : public TEdit
{
    bool bGotValue;
    bool bValueChanged;
    bool bCounted;  //for speedbutton.count already in(de)creased!
    bool bInProcess;
    bool FRegHex;
    TColor FColor;
    ERegType            FRegType;
    ERegRootKey         FRegRoot;

    int FRegDW_read;
    //int FRegDW_checked;
    //int FRegDW_unchecked;
    //static int FCurrentCount;
    int FRegDW_default; //safe to delete if it is default


    System::AnsiString  FRegSTR_read;
    //System::AnsiString  FRegSTR_checked;
    //System::AnsiString  FRegSTR_unchecked;
    System::AnsiString  FRegSTR_default;
    System::AnsiString  FRegKeyName;
    System::AnsiString  FRegValueName;

    static TRegSpeedButton* FSButton1;
    static TRegSpeedButton* FSButton2;
    static TRichEdit* FEdit;

    //static bool bNeedEnableButton;
    //static bool bNeedShowText;

protected:
    void __fastcall Change(void);
    void __fastcall Loaded(void);
    bool __fastcall ValueChanged(void);
    void __fastcall SetRootKey(TRegistry* reg);
    void __fastcall GetRegValue(void);
    void __fastcall MouseMove(TShiftState Shift, int X, int Y);
public:
    static void __fastcall SetFriend(TRegSpeedButton* fs1,TRegSpeedButton* fs2,TRichEdit* fe);
    __fastcall TEditReg(TComponent* Owner);
    void __fastcall SetRegValue(void);

__published:
    __property ERegType RegType={read=FRegType,write=FRegType};
    __property ERegRootKey RegRoot={read=FRegRoot,write=FRegRoot};
    __property System::AnsiString RegKeyName={read=FRegKeyName,write=FRegKeyName};
    __property System::AnsiString RegValueName={read=FRegValueName,write=FRegValueName};
    __property bool RegHex={read=FRegHex,write=FRegHex};

    //__property int RegDW_checked={read=FRegDW_checked,write=FRegDW_checked};
    //__property int RegDW_unchecked={read=FRegDW_unchecked,write=FRegDW_unchecked};
    __property int RegDW_default={read=FRegDW_default,write=FRegDW_default};
    //__property System::AnsiString RegSTR_checked={read=FRegSTR_checked,write=FRegSTR_checked};
    //__property System::AnsiString RegSTR_unchecked={read=FRegSTR_unchecked,write=FRegSTR_unchecked};
    __property System::AnsiString RegSTR_default={read=FRegSTR_default,write=FRegSTR_default};

};
TRegSpeedButton* TEditReg::FSButton1=NULL;
TRegSpeedButton* TEditReg::FSButton2=NULL;
//int TEditReg::FCurrentCount=0;
TRichEdit* TEditReg::FEdit=NULL;
//bool TEditReg::bNeedEnableButton=true;
//bool TEditReg::bNeedShowText=true;
//---------------------------------------------------------------------------
#endif
